<template>
    <v-row>
        <v-col cols="12">
            <v-card>
                <data-table
                    endpoint="api/holidays"
                    v-model="holidays"
                    :headers="headers"
                    :title="$t('holiday')"
                    :search-label="searchLabel"
                    :force-fetch.sync="forceFetch"
                >
                    <template v-slot:buttons>
                        <v-btn
                            class="mr-4"
                            color="primary"
                            @click="openCreateDialog = true"
                        >
                            <v-icon left>mdi-plus</v-icon>
                            {{ $tc('holiday') }}
                        </v-btn>
                    </template>

                    <template v-slot:item="{ item, index }">
                        <tr>
                            <td>{{ item.label }}</td>
                            <td>{{ item.from | date }}</td>
                            <td>{{ item.to | date }}</td>
                            <td>
                                <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>

                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                text
                                                block
                                                class="text-capitalize"
                                                color="primary"
                                                @click="onEdit(item)"
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $t('edit') }}
                                            </v-btn>
                                        </v-list-item>
                                        <v-divider class="my-2"></v-divider>
                                        <v-list-item>
                                            <v-btn
                                                text
                                                block
                                                class="text-capitalize"
                                                color="error"
                                                @click="onDelete(item)"
                                            >
                                                <v-icon left>mdi-delete</v-icon>
                                                {{ $t('delete') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </td>
                        </tr>
                    </template>
                </data-table>
            </v-card>
        </v-col>

        <v-dialog
            v-if="openCreateDialog"
            v-model="openCreateDialog"
            width="340"
        >
            <v-card>
                <v-card-title class="primary white--text">
                    {{ $t('create_', [$t('holiday')] )}}
                </v-card-title>
                <v-card-text class="pa-2">
                    <holiday-form
                        :errors="errors"
                        :loading="loading"
                        @validated="createHoliday"
                    ></holiday-form>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="selectedHoliday"
            v-model="openEditDialog"
            @click:outside="closeEdit"
            width="340"
        >
            <v-card>
                <v-card-title class="primary white--text">
                    {{ $t('edit_', [$t('holiday')] )}}
                </v-card-title>
                <v-card-text class="pa-2">
                    <holiday-form
                        mode="edit"
                        :value="selectedHoliday"
                        :errors="errors"
                        :loading="loading"
                        @validated="editHoliday"
                    ></holiday-form>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="selectedHoliday"
            v-model="openDeleteDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$tc('timeslot', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="closeDelete"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="deleteHoliday"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import DataTable from "../DataTable";
    import HolidayForm from "./HolidayForm";
    import { mapMutations } from "vuex";

    export default {
        name: "Holiday",
        components: {HolidayForm, DataTable},
        data: () => ({
            loading: false,
            holidays: [],
            errors: [],
            selectedHoliday: {},
            openCreateDialog: false,
            openEditDialog: false,
            openDeleteDialog: false,
            forceFetch: false
        }),
        computed: {
            headers() {
                return [
                    { text: this.$t('label'), value: 'label', sortable: false },
                    { text: this.$t('from'), value: 'from', sortable: false },
                    { text: this.$t('to'), value: 'to', sortable: false },
                    { text: this.$tc('action', 2), value: 'action', sortable: false },
                ]
            },
            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('label')
                })
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            createHoliday(payload) {
                this.loading = true

                axios.post('api/holidays', payload)
                    .then(() => {
                        this.forceFetch = true
                        this.success(this.$t('holiday_action.created'))
                        this.openCreateDialog = false
                    })
                    .catch(({ response }) => {
                        if(response.status === 422) {
                            this.errors = response.data.errors
                        }
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            editHoliday(payload) {
                this.loading = true

                axios.put(`api/holidays/${this.selectedHoliday.id}`, payload)
                    .then(() => {
                        this.forceFetch = true
                        this.success(this.$t('holiday_action.updated'))
                        this.closeEdit()
                    })
                    .catch(({ response }) => {
                        if(response.status === 422) {
                            this.errors = response.data.errors
                        }
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            deleteHoliday() {
                this.loading = true

                axios.delete(`api/holidays/${this.selectedHoliday.id}`)
                    .then(() => {
                        this.forceFetch = true
                        this.success(this.$t('holiday_action.deleted'))
                        this.closeDelete()
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message)
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            onEdit(holiday) {
                this.selectedHoliday = holiday
                this.openEditDialog = true
            },
            closeEdit() {
                this.openEditDialog = false
                this.selectedHoliday = {}
            },
            onDelete(holiday) {
                this.selectedHoliday = holiday
                this.openDeleteDialog = true
            },
            closeDelete() {
                this.openDeleteDialog = false
                this.selectedHoliday = {}
            }
        }
    }
</script>

<style scoped>

</style>
